// http://www.cepstrum.co.jp/
//
// fast FIR filter function test program
// use external memory (SDRAM), near call
//
// opt. level of    10000tap FIR filter
// firfunc.c        execution clock       clock/sample
// ---------------------------------------------------
// none             461500                46
// -o0 (register)   220200                22
// -o1 (local)      190200                19
// -o2 (function)    51400                 5

#define  FIR_LEN 10000

float    x, y;
#pragma  DATA_SECTION(fir_buf, "sdram");
float    fir_buf[2*FIR_LEN];
#pragma  DATA_SECTION(fir_coef, "sdram");
float    fir_coef[FIR_LEN];unsigned fir_ix;
unsigned temp;

float fast_fir(float, float[], float[], unsigned*, unsigned);

void main(void) {
  // initialize FIR filter
  for (temp=0; temp<FIR_LEN; temp=temp+1) {
    fir_coef[temp]=0.0;
    fir_buf[temp]=0.0;
    fir_buf[temp+FIR_LEN]=0.0;
  }
  y=fast_fir(x, fir_coef, fir_buf, &fir_ix, FIR_LEN);
}

